// GPIO Initialization GUIDlg.cpp : implementation file
//

#include "stdafx.h"
#include "GPIO Initialization GUI.h"
#include "GPIO Initialization GUIDlg.h"
#include"registers.h"
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CGPIOInitializationGUIDlg dialog

CGPIOInitializationGUIDlg::CGPIOInitializationGUIDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CGPIOInitializationGUIDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CGPIOInitializationGUIDlg)
	//}}AFX_DATA_INIT
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	PortB_gpio_opt[0].interrupt_available=FALSE;//disable the interrupt option for port B pin 0;
	PortB_gpio_opt[1].interrupt_available=FALSE;//disable the interrupt option for port B pin 1;
	for(i=0;i<8;i++)
	{
		PortA_gpio_opt[i].Pin_No=i;
		PortA_gpio_opt[i].port='A';
	}
	for(i=0;i<2;i++)
	{
		PortB_gpio_opt[i].Pin_No=i;
		PortB_gpio_opt[i].port='B';
	}
	PortC_gpio_opt[0].Pin_No=0;
	PortC_gpio_opt[0].port='C';
	T0IN.tnum=0;//timer 0
	T1IN.tnum=1;//timer 1
}

void CGPIOInitializationGUIDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CGPIOInitializationGUIDlg)
	DDX_Control(pDX, IDC_PC0SEL, m_pc0);
	DDX_Control(pDX, IDC_PB1SEL, m_pb1);
	DDX_Control(pDX, IDC_PB0SEL, m_pb0);
	DDX_Control(pDX, IDC_PA7SEL, m_pa7);
	DDX_Control(pDX, IDC_PA6SEL, m_pa6);
	DDX_Control(pDX, IDC_PA5SEL, m_pa5);
	DDX_Control(pDX, IDC_PA4SEL, m_pa4);
	DDX_Control(pDX, IDC_PA3SEL, m_pa3);
	DDX_Control(pDX, IDC_PA2SEL, m_pa2);
	DDX_Control(pDX, IDC_PA1SEL, m_pa1);
	DDX_Control(pDX, IDC_PA0SEL, m_pa0);
	DDX_Control(pDX, IDC_MCLABEL, m_label);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CGPIOInitializationGUIDlg, CDialog)
	//{{AFX_MSG_MAP(CGPIOInitializationGUIDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON8, OnButton8)
	ON_BN_CLICKED(IDC_BUTTON9, OnButton9)
	ON_BN_CLICKED(IDC_BUTTON10, OnButton10)
	ON_BN_CLICKED(IDC_BUTTON11, OnButton11)
	ON_BN_CLICKED(IDC_BUTTON12, OnButton12)
	ON_BN_CLICKED(IDC_BUTTON13, OnButton13)
	ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
	ON_BN_CLICKED(IDC_BUTTON2, OnButton2)
	ON_BN_CLICKED(IDC_BUTTON22, OnButton22)
	ON_BN_CLICKED(IDC_BUTTON_GCODE, OnButtonGcode)
	ON_BN_CLICKED(IDC_BUTTON19, OnButton19)
	ON_BN_CLICKED(IDC_BUTTON18, OnButton18)
	ON_BN_CLICKED(IDC_BUTTON20, OnButton20)
	ON_BN_CLICKED(IDC_RESET, OnReset)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CGPIOInitializationGUIDlg message handlers

BOOL CGPIOInitializationGUIDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	boldfont.CreateFont(15,0,0,0,FW_HEAVY,0,0,0,0,0,0,0,0,"Ariel");	
	m_label.SetFont(&boldfont);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CGPIOInitializationGUIDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}

}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CGPIOInitializationGUIDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

HCURSOR CGPIOInitializationGUIDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

BOOL CGPIOInitializationGUIDlg::PreCreateWindow(CREATESTRUCT& cs) 
{
	// TODO: Add your specialized code here and/or call the base class
	
	return CDialog::PreCreateWindow(cs);
}


void CGPIOInitializationGUIDlg::CalcWindowRect(LPRECT lpClientRect, UINT nAdjustType) 
{
	// TODO: Add your specialized code here and/or call the base class
	
	CDialog::CalcWindowRect(lpClientRect, nAdjustType);
}


void CGPIOInitializationGUIDlg::OnButton8() 
{
	// TODO: Add your control notification handler code here
	if(PortA_opt[0].DoModal()==IDOK)
	{
		userchoice=IDCANCEL;
		switch(PortA_opt[0].m_iPinOption)
		{
		case 0: userchoice=PortA_gpio_opt[0].DoModal();//GPIO options is selected								
				constring="PA0";
				break;
		case 1:				//Alternate function selected
				userchoice=T0IN.DoModal();				
				constring="T0IN";
				break;					
		}

		if(userchoice==IDOK)
		{
			PortA_opt[0].configured=TRUE;
			m_pa0.SetWindowText(constring);
			
		}
		else
		{
			PortA_opt[0].configured=FALSE;
			PortA_opt[0].m_iPinOption=0;
			m_pa0.SetWindowText("");
		}
	}
}

void CGPIOInitializationGUIDlg::OnButton9() 
{
	// TODO: Add your control notification handler code here
	
	if(PortA_opt[1].DoModal()==IDOK)
	{
		userchoice=IDCANCEL;
		switch(PortA_opt[1].m_iPinOption)
		{
		case 0: 	
				userchoice=PortA_gpio_opt[1].DoModal();
				constring="PA1";
			break;
		case 1:				//Alternate function selected
				userchoice=T0OUT.DoModal();
				if(T0OUT.m_tout_enable)//configure pin for TOUT only Timer output is Enabled
				constring="T0OUT";				
				else
					userchoice=IDCANCEL;
			break;
		}
		
		if(userchoice==IDOK)
		{
			PortA_opt[1].configured=TRUE;
			m_pa1.SetWindowText(constring);
		}
		else
		{
			PortA_opt[1].configured=FALSE;
			PortA_opt[1].m_iPinOption=0;
			m_pa1.SetWindowText("");
		}

	}
	
}

void CGPIOInitializationGUIDlg::OnButton10() 
{
	// TODO: Add your control notification handler code here
	
	if(PortA_opt[2].DoModal()==IDOK)
	{
		userchoice=IDCANCEL;
		switch(PortA_opt[2].m_iPinOption)
		{
		case 0: 	userchoice=PortA_gpio_opt[2].DoModal();
			constring="PA2";
			break;
		case 1:				//Alternate function selected
			break;		
		}

		if(userchoice==IDOK)
		{
			PortA_opt[2].configured=TRUE;
			m_pa2.SetWindowText(constring);
		}
		else
		{
			PortA_opt[2].configured=FALSE;
			PortA_opt[2].m_iPinOption=0;
			m_pa2.SetWindowText("");
		}

	}
}

void CGPIOInitializationGUIDlg::OnButton11() 
{
	// TODO: Add your control notification handler code here
	
	if(PortA_opt[3].DoModal()==IDOK)
	{	
		userchoice=IDCANCEL;
		switch(PortA_opt[3].m_iPinOption)
		{
		case 0:userchoice=PortA_gpio_opt[3].DoModal();
			constring="PA3";
			break;
		case 1:				//Alternate function selected
			UART_opt.m_ctse=1;
			registers::U0CTL0|=0x20;//Switch On the CTSE Bit
			constring="CTS0";
			break;		
		}
		
		if(userchoice==IDOK&&constring=="PA3"&&registers::U0CTL0&0x20)//if Gpio is selected and CTSE is enabled
		{
			registers::U0CTL0&=~0x20;//Switch off the CTSE Bit			
			UART_opt.m_ctse=0;
		}
						
		if(userchoice==IDOK||constring=="CTS0")
		{
			PortA_opt[3].configured=TRUE;
			m_pa3.SetWindowText(constring);
		}
		else
		{
			PortA_opt[3].configured=FALSE;
			PortA_opt[3].m_iPinOption=0;
			m_pa3.SetWindowText("");
		}

	}
}

void CGPIOInitializationGUIDlg::OnButton12() 
{
	// TODO: Add your control notification handler code here
	
	if(PortA_opt[4].DoModal()==IDOK)
	{
		userchoice=IDCANCEL;
		switch(PortA_opt[4].m_iPinOption)
		{
		case 0: userchoice=PortA_gpio_opt[4].DoModal();
			constring="PA4";
			break;
		case 1:				//Alternate function selected
			userchoice=UART_opt.DoModal();
			constring="RXDO";
			break;		
		}
		if(userchoice==IDOK&&registers::U0CTL0&64||constring=="PA4")
		{
			PortA_opt[4].configured=TRUE;
			m_pa4.SetWindowText(constring);
		}
		else
		{
			PortA_opt[4].configured=FALSE;
			PortA_opt[4].m_iPinOption=0;
			m_pa4.SetWindowText("");
		}

		if(registers::U0CTL0&128)//if UART Reciever is also configured
		{
			PortA_opt[5].configured=TRUE;
			m_pa5.SetWindowText("RXD0");
		}


		if(registers::U0CTL0&0x20)//if CTSE Bit is on
		{
			PortA_opt[3].configured=TRUE;
			m_pa3.SetWindowText("CTS0");
		}

	}
	
}

void CGPIOInitializationGUIDlg::OnButton13() 
{
	// TODO: Add your control notification handler code here
	if(PortA_opt[5].DoModal()==IDOK)
	{
		userchoice=IDCANCEL;
		switch(PortA_opt[5].m_iPinOption)
		{
		case 0:userchoice=PortA_gpio_opt[5].DoModal();
			constring="PA5";
			break;
		case 1:				//Alternate function selected
			userchoice=UART_opt.DoModal();
			constring="TXDO";
			break;		
		}

		if(userchoice==IDOK&&registers::U0CTL0&128||constring=="PA5")
		{
			PortA_opt[5].configured=TRUE;
			m_pa5.SetWindowText(constring);
		}
		else
		{
			PortA_opt[4].configured=FALSE;
			PortA_opt[5].m_iPinOption=0;
			m_pa5.SetWindowText("");
		}						
		
		if(registers::U0CTL0&64)//if UART Reciever is also configured
		{
			PortA_opt[4].configured=TRUE;
			m_pa4.SetWindowText("RXD0");
		}

		if(registers::U0CTL0&0x20)//if CTSE Bit is on
		{
			PortA_opt[3].configured=TRUE;
			m_pa3.SetWindowText("CTS0");
		}


	}
}

void CGPIOInitializationGUIDlg::OnButton1() 
{
	// TODO: Add your control notification handler code here

	if(PortA_opt[6].DoModal()==IDOK)
	{
		userchoice=IDCANCEL;
		switch(PortA_opt[6].m_iPinOption)
		{
		case 0: userchoice=PortA_gpio_opt[6].DoModal();		
			constring="PA6";
			break;
		case 1:				//Alternate function selected

			break;		
		}
		if(userchoice==IDOK)
		{
			PortA_opt[6].configured=TRUE;
			m_pa6.SetWindowText(constring);
		}
		else
		{
			PortA_opt[6].configured=FALSE;
			PortA_opt[6].m_iPinOption=0;
			m_pa6.SetWindowText("");
		}
	}
}

void CGPIOInitializationGUIDlg::OnButton2() 
{
	// TODO: Add your control notification handler code here
	
	if(PortA_opt[7].DoModal()==IDOK)
	{
		userchoice=IDCANCEL;
		switch(PortA_opt[7].m_iPinOption)
		{
		case 0: userchoice=PortA_gpio_opt[7].DoModal();		
			constring="PA7";
			break;
		case 1:				//Alternate function selected
			break;		
		}

		if(userchoice==IDOK)
		{
			PortA_opt[7].configured=TRUE;
			m_pa7.SetWindowText(constring);
		}
		else
		{
			PortA_opt[7].configured=FALSE;
			PortA_opt[7].m_iPinOption=0;
			m_pa7.SetWindowText("");
		}
	}
}


void CGPIOInitializationGUIDlg::OnButton22() 
{
	// TODO: Add your control notification handler code here
	OnOK();
	
}



void CGPIOInitializationGUIDlg::OnButton19() 
{
	// TODO: Add your control notification handler code here
	
				if(PortB_gpio_opt[0].DoModal()==IDOK)
				{
					PortB_opt[0].configured=TRUE;
					m_pb0.SetWindowText("PB0");
				}
				else
				{
					PortB_opt[0].configured=FALSE;
					m_pb0.SetWindowText("");
				}


}

void CGPIOInitializationGUIDlg::OnButton18() 
{
	// TODO: Add your control notification handler code here
				if(PortB_gpio_opt[1].DoModal()==IDOK)
				{
					PortB_opt[1].configured=TRUE;
					m_pb1.SetWindowText("PB1");
				}
				else
				{
					PortB_opt[1].configured=FALSE;
					m_pb1.SetWindowText("");
				}

}

void CGPIOInitializationGUIDlg::OnButton20() 
{
	// TODO: Add your control notification handler code here
	if(PortC_opt[0].DoModal()==IDOK)
	{
		userchoice=IDCANCEL;
		switch(PortC_opt[0].m_iPinOption)
		{		
		case 0: userchoice=PortC_gpio_opt[0].DoModal();		//GPIO options is selected
				constring="PC0";
				break;
		case 1:				//Alternate function selected
				userchoice=T1IN.DoModal();				
				constring="T1IN";
				break;					

			break;		
		}

		if(userchoice==IDOK)
		{
			PortC_opt[0].configured=TRUE;
			m_pc0.SetWindowText(constring);
		}
		else
		{
			PortC_opt[0].configured=FALSE;
			PortC_opt[0].m_iPinOption=0;
			m_pc0.SetWindowText("");
		}
	}	
}


void CGPIOInitializationGUIDlg::OnButtonGcode() 
{
	// TODO: Add your control notification handler code here
	for(i=0;i<8;i++)
	{
		if(!PortA_opt[i].configured)
		{
			userchoice=MessageBox("Port A pins configuration is not complete. Continue with Default configuration ?","Generate Code",MB_YESNO|MB_ICONQUESTION);
			if(userchoice==IDNO)
			return;	
			else
			break;
		}
	}

	for(i=0;i<2;i++)
	{
		if(!PortB_opt[i].configured)
		{
			userchoice=MessageBox("Port B pins configuration is not complete. Continue with Default configuration ?","Generate Code",MB_YESNO|MB_ICONQUESTION);
			if(userchoice==IDNO)
			return;	
			else
			break;
		}
	}

	if(!PortC_opt[0].configured)
	{
		userchoice=MessageBox("Port C pin configuration is not complete. Continue with Default configuration ?","Generate Code",MB_YESNO|MB_ICONQUESTION);
		if(userchoice==IDNO)
			return;	
	}

		CString szFilter="C source (*.c)|*.c||";
		CFileDialog filedialog(FALSE,NULL,NULL,NULL, szFilter);
		CString filename;

		
		if(filedialog.DoModal()==IDOK)
		{	
			CString ext=filedialog.GetFileExt();
			if(ext.GetLength()==0)//if file extension is not supplied, add the extension name
			{			
				filename=filedialog.GetPathName()+".c";
			}
			else
				filename=filedialog.GetPathName();
	
			CreateHeaderFile();
			CreateGpioFile();
			CreateTimerFile();
			CreateUARTFile();
			CCodeSet="";
			//Creating the Main file
			CCodeSet+="#include \"ez8.h\"\n";//Add header files inclusion
			CCodeSet+="#include \"main.h\"\n";
			CCodeSet+="#include \"gpio.c\"\n";
			CCodeSet+="#include \"timer.c\"\n";
			CCodeSet+="void main()\n{\n\n\t/*Main Function Body*/\n";
			CCodeSet +="\n\tgpio_init();";
			CCodeSet+="\n\tDI();";

			if(PortA_opt[0].m_iPinOption&&PortA_opt[0].configured)//if Timer 0 alternate function is present, add function call statement
				CCodeSet +="\n\ttimer0_init();";

			if(PortC_opt[0].m_iPinOption&&PortC_opt[0].configured)//if Timer 1 alternate function is present add function call statement
				CCodeSet +="\n\ttimer1_init();";

			if(registers::U0CTL0&128||registers::U0CTL0&64)//if UART transmitter or Reciever is enabled
				CCodeSet +="\n\tUART_init();";
			CCodeSet+="\n\tEI();";				
			CCodeSet+="\n}";
			outfile.open(filename);//The main file
			outfile<<CCodeSet;
			outfile.close();
		}	
			
}


void CGPIOInitializationGUIDlg::OnReset() 
{
	// TODO: Add your control notification handler code here
	userchoice=MessageBox("This will Reset all the configuration (Register Values). Do you want to continue?","Reset",MB_YESNO|MB_ICONQUESTION);
	if(userchoice==IDOK)
	{

		GPIOoptions::RESET();//reset all the register values;
		registers::Reset();

		for(i=0;i<8;i++)		//reset all the dialog control variables of Port A
		{
			PortA_opt[i].configured=FALSE;
			PortA_opt[i].m_iPinOption=0;
			PortA_gpio_opt[i].m_hdrive_opt=0;
			PortA_gpio_opt[i].m_interrupt_opt=0;
			PortA_gpio_opt[i].m_iopin_opt=0;
			PortA_gpio_opt[i].m_odrain_opt=0;
			PortA_gpio_opt[i].m_smr_opt=0;
		}
	
		for(i=0;i<2;i++)		//Resed all the Dialog control variables of Port B
		{
			PortB_opt[i].configured=FALSE;
			PortB_opt[i].m_iPinOption=0;
			PortB_gpio_opt[i].m_hdrive_opt=0;
			PortB_gpio_opt[i].m_interrupt_opt=0;
			PortB_gpio_opt[i].m_iopin_opt=0;
			PortB_gpio_opt[i].m_odrain_opt=0;
			PortB_gpio_opt[i].m_smr_opt=0;
		}
	
		PortC_opt[0].configured=FALSE;
		PortC_opt[0].m_iPinOption=0;
		PortC_gpio_opt[i].m_hdrive_opt=0;
		PortC_gpio_opt[i].m_interrupt_opt=0;
		PortC_gpio_opt[i].m_iopin_opt=0;
		PortC_gpio_opt[i].m_odrain_opt=0;
		PortC_gpio_opt[i].m_smr_opt=0;
	

		T0OUT.m_tout_enable=0;

		UART_opt.m_baud_rate=0;
		UART_opt.m_ctse=0;
		UART_opt.m_mpbt=0;
		UART_opt.m_mpen=0;
		UART_opt.m_mpmd=0;
		UART_opt.m_parity=0;
		UART_opt.m_reciever=0;
		UART_opt.m_reciever_interrupt=0;
		UART_opt.m_transmit=0;
		UART_opt.m_transmitter_interrupt=0;

		m_pa0.SetWindowText("");
		m_pa1.SetWindowText("");
		m_pa2.SetWindowText("");
		m_pa3.SetWindowText("");
		m_pa4.SetWindowText("");
		m_pa5.SetWindowText("");
		m_pa6.SetWindowText("");
		m_pa7.SetWindowText("");
		m_pb0.SetWindowText("");
		m_pb1.SetWindowText("");
		m_pc0.SetWindowText("");
	}
}



void CGPIOInitializationGUIDlg::CreateHeaderFile()
{
			//Code Generation for Function Prototypes starts here...
			CCodeSet="";
			CCodeSet +="ifndef main_h\n#define main_h";
			CCodeSet +="\nvoid gpio_init(void);";

			if(PortA_opt[0].m_iPinOption&&PortA_opt[0].configured)//if Timer 0 alternate function is present add the prototype
				CCodeSet +="\nvoid timer0_init(void);";

			if(PortC_opt[0].m_iPinOption&&PortC_opt[0].configured)//if Timer 1 alternate function is present add the prototype
				CCodeSet +="\nvoid timer1_init(void);";

			if(registers::U0CTL0&128||registers::U0CTL0&64)//if UART transmitter or Reciever is enabled
				CCodeSet +="\nvoid UART_init(void);";

			for(i=0;i<8;i++)//Port A interrupt Set vector prototypes
			{
				if(PortA_gpio_opt[i].m_iopin_opt==0&&PortA_gpio_opt[i].m_interrupt_opt&&PortA_opt[i].configured)
				{				
					CCode.Format("\nvoid isr_PA%d(void);",i);
					CCodeSet +=CCode;
				}
			}

			if(PortC_gpio_opt[0].m_iopin_opt==0&&PortC_gpio_opt[0].m_interrupt_opt&&PortC_opt[0].configured)//Port C pin 0 Interrupt Service routine function prototype
				CCodeSet +="\nvoid isr_PC0(void);";
			
			if(PortA_opt[0].m_iPinOption==1&&T0IN.m_interrupt_opt&&PortA_opt[0].configured)//Port A  Timer 0 interrupt Service Routine function prototype
				CCodeSet +="\nvoid isr_T0(void);";

			if(registers::IRQ0ENH&0x10||registers::IRQ0ENL&0x10)//if Reciever Interrupt Is Enabled, add isr prototype
				CCodeSet +="\nvoid isr_U0R(void);";

			if(registers::IRQ0ENH&0x8||registers::IRQ0ENL&0x8)//if Transmitter Interrupt Is Enabled, add isr prototype
				CCodeSet +="\nvoid isr_U0T(void);";
		
			CCodeSet +="\n#endif";
			
			outfile.open("main.h");//Open main.h for writing
			outfile<<CCodeSet;//write the Code
			outfile.close();//Close file

}


void CGPIOInitializationGUIDlg::CreateGpioFile()
{
			
			
			//Code Generation for gpio_init() function starts here..
			CCodeSet="";
			CCodeSet+="\n\nvoid gpio_init(void)\n{";

			//Code Generation for Data Direction starts here...
			//Port A Data Direction
			CCodeSet+="\n\n\t/*Port A Data direction*/";
			CCode.Format("\n\tPAADDR=0x01;\n\tPACTL|=0x%X;\n\tPAADDR=0x00;",GPIOoptions::PortA.DD);
			CCodeSet+=CCode;
					
			//Port B Data Direction
			CCodeSet+="\n\n\t/*Port B Data direction*/";
			CCode.Format("\n\tPBADDR=0x01;\n\tPBCTL|=0x%X;\n\tPBADDR=0x00;",GPIOoptions::PortB.DD);
			CCodeSet+=CCode;			
					
			//Port C Data Direction
			CCodeSet+="\n\n\t/*Port C Data direction*/";
			CCode.Format("\n\tPCADDR=0x01;\n\tPCCTL|=0x%X;\n\tPCADDR=0x00;",GPIOoptions::PortC.DD);
			CCodeSet+=CCode;			
			//Code Generation for Data Direction Ends here.
		
			
			//Code Generation for Output Control Starts here....
			//for Output Control to be enabled, Data Direction Should be Output.
			
			//Port A output Control
			if(GPIOoptions::PortA.OC)
			{
				CCodeSet+="\n\n\t/*Port A Output Control*/";
				CCode.Format("\n\tPAADDR=0x03;\n\tPACTL|=0x%X;\n\tPAADDR=0x00;",GPIOoptions::PortA.OC);
				CCodeSet+=CCode;			
			}
			//Port B output Control
			if(GPIOoptions::PortB.OC)
			{
				CCodeSet+="\n\n\t/*Port B Output Control*/";
				CCode.Format("\n\tPBADDR=0x03;\n\tPBCTL|=0x%X;\n\tPBADDR=0x00;",GPIOoptions::PortB.OC);
				CCodeSet+=CCode;			
			}			
			//Port C output Control
			if(GPIOoptions::PortC.OC)			
			{
				CCodeSet+="\n\n\t/*Port C Output Control*/";
				CCode.Format("\n\tPCADDR=0x03;\n\tPCCTL|=0x%X;\n\tPCADDR=0x00;",GPIOoptions::PortC.OC);
				CCodeSet+=CCode;
			}


			//Code Generation for High Drive Enable/Disable Starts here....
			//for High Drive to be enabled, Data Direction Should be Output.
			
			//Port A High Drive Enable/Disable
			//Generates code only if any of the pin is configured for High drive Enable
			if(GPIOoptions::PortA.HDE)
			{
				CCodeSet+="\n\n\t/*Port A High Drive Enable/Disable*/";
				CCode.Format("\n\tPAADDR=0x04;\n\tPACTL|=0x%X;\n\tPAADDR=0x00;",GPIOoptions::PortA.HDE);
				CCodeSet+=CCode;			
			}			
			//Port B High Drive
			if(GPIOoptions::PortB.HDE)
			{
				CCodeSet+="\n\n\t/*Port B High Drive Enable/Disable*/";			
				CCode.Format("\n\tPBADDR=0x04;\n\tPBCTL|=0x%X;\n\tPBADDR=0x00;",GPIOoptions::PortB.HDE);
				CCodeSet+=CCode;			
			}						
			//Port C High Drive
			if(GPIOoptions::PortC.HDE)
			{				
				CCodeSet+="\n\n\t/*Port C High Drive Enable/Disable*/";			
				CCode.Format("\n\tPCADDR=0x04;\n\tPCCTL|=0x%X;\n\tPCADDR=0x00;",GPIOoptions::PortC.HDE);
				CCodeSet+=CCode;
			}


			//Code Generation for STOP mode recovery Starts here....
			//for STOP Mode Recovery to be enabled, Data Direction Should be Input.
			
			//Port A SMR Enable/Disable
			if(GPIOoptions::PortA.SMR)
			{
				CCodeSet+="\n\n\t/*Port A SMR Enable/Disable*/";			
				CCode.Format("\n\tPAADDR=0x05;\n\tPACTL|=0x%X;\n\tPAADDR=0x00;",GPIOoptions::PortA.SMR);
				CCodeSet+=CCode;			
			}
			
			//Port B SMR Enable/Disable
			if(GPIOoptions::PortB.SMR)
			{
				CCodeSet+="\n\n\t/*Port B SMR Enable/Disable*/";			
				CCode.Format("\n\tPBADDR=0x05;\n\tPBCTL|=0x%X;\n\tPBADDR=0x00;",GPIOoptions::PortB.SMR);
				CCodeSet+=CCode;			
			}
						
			//Port C SMR Enable/Disable
			if(GPIOoptions::PortC.SMR)
			{
				CCodeSet+="\n\n\t/*Port C SMR Enable/Disable*/";			
				CCode.Format("\n\tPCADDR=0x05;\n\tPCCTL|=0x%X;\n\tPCADDR=0x00;",GPIOoptions::PortC.SMR);
				CCodeSet+=CCode;
			}

			//Code Generation for Interrupt Enable Starts here...
			//For interrupt to be enabled, the pin Data direction should be Input
			
			
			//Set the IRQ enable high and Low registers for PORT A
			
			if(registers::IRQ1ENH)//if any of the high bits are on
			{
				
				CCode.Format("\n\tIRQ1ENH=0x%X;/*IRQ Enable High for Port A pins*/",registers::IRQ1ENH);
				CCodeSet+=CCode;
			}
			if(registers::IRQ1ENL)//if any of the low bits are on
			{
				CCode.Format("\n\tIRQ1ENL=0x%X;/*IRQ Enable Low for Port A pins*/",registers::IRQ1ENL);
				CCodeSet+=CCode;
			}
			
			if(registers::IRQES)//If Port A pins Interrupt Edge Selection is made.
			{
				CCodeSet+="\n\n\t/*Interrupt Edge Select of Port A pins*/";
				CCode.Format("\n\tIRQES=0x%X;",registers::IRQES);
				CCodeSet+=CCode;
			}

			for(i=0;i<8;i++)//Port A interrupt Set vector code generation
			{
				if(PortA_gpio_opt[i].m_iopin_opt==0&&PortA_gpio_opt[i].m_interrupt_opt&&PortA_opt[i].configured)
				{				
					CCode.Format("\n\n\t/*Port A pin %d Interrupt Set Vector*/",i);
					CCodeSet+=CCode;
					CCode.Format("\n\tSET_VECTOR(PA%d,isr_PA%d);",i,i);
					CCodeSet+=CCode;
				}
			}
			
			if(registers::IRQ2ENH)//if any of the high bits are on
			{
				CCode.Format("\n\tIRQ2ENH|=%X;/*IRQ Enable High for Port C pins*/",registers::IRQ2ENH);
				CCodeSet+=CCode;
			}
			
			if(registers::IRQ2ENL)//if any of the low bits are on
			{
				CCode.Format("\n\n\tIRQ2ENL|=%X;/*IRQ Enable Low for Port C pins*/",registers::IRQ2ENL);
				CCodeSet+=CCode;
			}
			
			if(PortC_gpio_opt[0].m_iopin_opt==0&&PortC_gpio_opt[0].m_interrupt_opt&&PortC_opt[0].configured)//Port C Set Vector Code generation
			{				
				CCode.Format("\n\n\t/*Port C pin 0 Interrupt Set Vector*/",i);
				CCodeSet+=CCode;
				CCodeSet+="\n\tSET_VECTOR(PC0,isr_PC0);";
			}
			
			CCodeSet+="\n}";
			//Code Generation for gpio_init() function ends here.
		    
			//Code Generation for Port A  ISR function body starts here...
			for(i=0;i<8;i++)//Port A interrupt Service Routine functions
			{
				if(PortA_gpio_opt[i].m_iopin_opt==0&&PortA_gpio_opt[i].m_interrupt_opt&&PortA_opt[i].configured)
				{				
					CCode.Format("\n\n#pragma interrupt\nvoid isr_PA%d(void)\n{\n\t/*Interrupt Service Routine for Port A pin %d*/\n}",i,i);
					CCodeSet+=CCode;
				}
			}
			
			//Port C interrupt Service Routine function
			if(PortC_gpio_opt[0].m_iopin_opt==0&&PortC_gpio_opt[0].m_interrupt_opt&&PortC_opt[0].configured)
				CCodeSet+="\n\n#pragma interrupt\nvoid isr_PC0(void)\n{\n\t/*Interrupt Service Routine for Port C pin 0*/\n}";
			
			FormatCode(&CCodeSet);
			outfile.open("gpio.c");
			outfile<<CCodeSet;			
			outfile.close();

}


void CGPIOInitializationGUIDlg::CreateTimerFile()
{
				CCodeSet="";//empty code string
				//Code Generation for PorA 0 Timer Input Alternate function
				if(PortA_opt[0].m_iPinOption==1&&PortA_opt[0].configured)//if port A pin Timer 0 Alternate function is selected.
				{
					CCodeSet+="\n\n/*Port A Timer 0 Alternate Function*/";
					CCodeSet+="\nvoid timer0_init(void)\n{";
					
					
					if(PortA_opt[1].configured&&T0OUT.m_tout_enable)//if timer 0 output is enabled
						CCodeSet+="\n\tPAADDR=0x02;\n\tPACTL|=0x03;/*Enable Timer 0 Input & Timer 0 output Alternate Functions*/\n\tPAADDR=0x00;";
					else
						CCodeSet+="\n\tPAADDR=0x02;\n\tPACTL|=0x01;/*Enable Timer 0 Input Alternate Functions*/\n\tPAADDR=0x00;";

					CCode.Format("\n\tT0CTL|=0x%X;\n\tT0H=0x%X;\n\tT0L=0x%X;\n\tT0RH=0x%X;\n\tT0RL=0x%X;",registers::T0CTL,T0IN.TH,T0IN.TL,T0IN.RH,T0IN.RL);
					
					CCodeSet+=CCode;

					
					if(T0IN.m_tmode==3||T0IN.m_tmode==4)
					{
						CCode.Format("\n\tT0PWMH=0x%X;\n\tT0PWML=0x%X;",T0IN.PWMH,T0IN.PWML);
						CCodeSet+=CCode;
					}

					if(T0IN.m_interrupt_opt)//if interrupt is to be generated
					{	
						CCodeSet+="\n\n\t/*Timer 0 Interrupt Set Vector*/";
						CCode.Format("\n\tSET_VECTOR(T0,isr_T0);");
						CCodeSet+=CCode;
					}				
				
				CCode.Format("\n\tIRQ0ENH|=0x%X;/* Set the Enable High/Low bit for Timer 0 and Timer 1 interrupts\n\tIRQ0ENL|=0x%X;",registers::IRQ0ENH,registers::IRQ0ENL);				
				CCodeSet+="\n}";
				}//Timer 0 alternate function ends here.

	

				
				//Code Generation for PorC  Timer 1 Input Alternate function
				if(PortC_opt[0].m_iPinOption==1&&PortC_opt[0].configured)//if port C pin Timer 1 Alternate function is selected.
				{
					CCodeSet+="\n\n/*Port C Timer 1 Alternate Function*/";
					CCodeSet+="\ntimer1_init(void)\n{";

					CCode.Format("\n\tPCADDR=0x02;\n\tPCCTL|=0x01;\n\tPCADDR=0x00;\n\tT1CTL|=0x%X;\n\tT1H=0x%X;\n\tT1L=0x%X;\n\tT1RH=0x%X;\n\tT1RL=0x%X;",registers::T1CTL,T1IN.TH,T1IN.TL,T1IN.RH,T1IN.RL);
					CCodeSet+=CCode;
				
					if(T1IN.m_interrupt_opt)//if interrupt is to be generated
					{				
						
						CCode.Format("\n\tSET_VECTOR(T1,isr_T1);");
						CCodeSet+=CCode;
					}				
				
					CCode.Format("\n\tIRQ0ENH|=0x%X;/* Set the Enable High/Low bit for Timer 0 and Timer 1 interrupts\n\tIRQ0ENL|=0x%X;",registers::IRQ0ENH,registers::IRQ0ENL);									
					CCodeSet+="\n}";
				}//Timer 1 alternate function ends here.
			

		
			//Port A  Timer 0 interrupt Service Routine function
			if(PortA_opt[0].m_iPinOption==1&&T0IN.m_interrupt_opt&&PortA_opt[0].configured)
				CCodeSet+="\n\n#pragma interrupt\nvoid isr_T0(void)\n{\n\t/*Interrupt Service Routine for Port A Timer 0*/\n}";

			//Port C  Timer 1 interrupt Service Routine function
			if(PortC_opt[0].m_iPinOption==1&&T1IN.m_interrupt_opt&&PortC_opt[0].configured)
				CCodeSet+="\n\n#pragma interrupt\nvoid isr_T1(void)\n{\n\t/*Interrupt Service Routine for Port C Timer 1*/\n}";
			
			FormatCode(&CCodeSet);
			outfile.open("timer.c");//open timer.c
			outfile<<CCodeSet;//write timer coding
			outfile.close();//close file
}


void CGPIOInitializationGUIDlg::CreateUARTFile()//creating the UART configuration code
{

	CCodeSet="";
	if(registers::U0CTL0&128||registers::U0CTL0&64)//if UART transmitter or Reciever is enabled
	{
		CCodeSet+="void UART_init(void)\n{\n";
		if(registers::U0CTL0&128&&registers::U0CTL0&64&&registers::U0CTL0&0x20)//if Reciver, Transmitter & CTSE Bit is on
			CCode.Format("\n\tPAADDR=0x02;\n\tPACTL|=%X;\n\tPAADDR=0x00;",0x1C);//Enable Reciver, Transmitter & CTSE functions
		else
		if(registers::U0CTL0&128&&registers::U0CTL0&64)//if both transmitter and reciever is Enabled
			CCode.Format("\n\tPAADDR=0x02;\n\tPACTL|=%X;\n\tPAADDR=0x00;",0x30);//Enable both alternate functions
		else
			if(registers::U0CTL0&128)
			CCode.Format("\n\tPAADDR=0x02;\n\tPACTL|=0x%X;\n\tPAADDR=0x00;",0x20);//Enable only Transmitter alternate function
		else
			CCode.Format("\n\tPAADDR=0x02;\n\tPACTL|=0x%X;\n\tPAADDR=0x00;",0x10);//Enable only Reciever alternate funciton
		CCodeSet+=CCode;//Write the code to enable the alternate function(s)

		CCode.Format("\n\tU0BRH=0x%X;\n\tU0BRL=0x%X;",registers::UBRH,registers::UBRL);
		CCodeSet+=CCode;//Write the Baud rate generator (BRG[15:0]) registers


		CCode.Format("\n\tU0CTL0=0x%X;\n\tU0CTL1=0x%X;",registers::U0CTL0,registers::U0CTL1);	//Set the UART Control Registers	
		CCodeSet+=CCode;
		
		if(registers::IRQ0ENH&0x10||registers::IRQ0ENL&0x10)//if Reciever Interrupt Is Enabled
		CCodeSet+="\n\tSET_VECTOR(U0R,isr_U0R);";

		if(registers::IRQ0ENH&0x8||registers::IRQ0ENL&0x8)//if Transmitter Interrupt Is Enabled
		CCodeSet+="\n\tSET_VECTOR(U0T,isr_U0R);";


		CCode.Format("\n\tIRQ0ENH|=0x%X;\n\tIRQ0ENL|=0x%X;",registers::IRQ0ENH,registers::IRQ0ENL);//Set The Interrupts
		CCodeSet+=CCode;

		CCodeSet+="\n}";	//here ends the UART init function

		//Adding the UART ISR's
		if(registers::IRQ0ENH&0x10||registers::IRQ0ENL&0x10)//if Reciever Interrupt Is Enabled
		CCodeSet+="\n\nvoid isr_U0R(void)\n{\n\t /*Reciever Interrupt Service Routine*/\n}";

		if(registers::IRQ0ENH&0x8||registers::IRQ0ENL&0x8)//if Transmitter Interrupt Is Enabled
		CCodeSet+="\n\nvoid isr_U0T(void)\n{\n\t /*Transmitter Interrupt Service Routine*/\n}";

	}

	FormatCode(&CCodeSet);
	outfile.open("UART.c");//open UART.c for writing
	outfile<<CCodeSet;//write the Code
	outfile.close();//Close file


}


void CGPIOInitializationGUIDlg::FormatCode(CString *StringSet)
{
	StringSet->Replace("0x0;","0x00;");
	StringSet->Replace("0x1;","0x01;");
	StringSet->Replace("0x2;","0x02;");
	StringSet->Replace("0x3;","0x03;");
	StringSet->Replace("0x4;","0x04;");
	StringSet->Replace("0x5;","0x05;");
	StringSet->Replace("0x6;","0x06;");
	StringSet->Replace("0x7;","0x07;");
	StringSet->Replace("0x8;","0x08;");
	StringSet->Replace("0x9;","0x09;");
}