// registers.h: interface for the registers class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_REGISTERS_H__FC9D812F_4EFA_4190_BA11_C371B9DBE426__INCLUDED_)
#define AFX_REGISTERS_H__FC9D812F_4EFA_4190_BA11_C371B9DBE426__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class registers  
{
public:
	registers();
	virtual ~registers();
	static unsigned char IRQ0ENH;//interrupt enable high for timer and UART
	static unsigned char IRQ0ENL;//interrupt enable Low for timer and UART
	static unsigned char IRQ1ENH;//Interrupt enable High for Port A GPIO
	static unsigned char IRQ1ENL;//Interrupt Enable Low for Port A GPIO
	static unsigned char IRQ2ENH;//Interrupt Enable High for Port C GPIO
	static unsigned char IRQ2ENL;//Interrupt Enable Low for Port C GPIO
	static unsigned char IRQES;//Interrupt Edge Select for Port A GPIO
	static unsigned char T0CTL;//Timer 0 Control Register
	static unsigned char T1CTL;//Timer 1 Control Register
	static unsigned char U0CTL0;
	static unsigned char U0CTL1;
	static unsigned char UBRH;
	static unsigned char UBRL;
	static void Reset();
};

#endif // !defined(AFX_REGISTERS_H__FC9D812F_4EFA_4190_BA11_C371B9DBE426__INCLUDED_)
