// GPIO Initialization GUIDlg.h : header file
//

#if !defined(AFX_GPIOINITIALIZATIONGUIDLG_H__A5480EB8_9030_415B_ACFB_28EF44AD0614__INCLUDED_)
#define AFX_GPIOINITIALIZATIONGUIDLG_H__A5480EB8_9030_415B_ACFB_28EF44AD0614__INCLUDED_
#include "fstream.h"
#include "GPIOoptions.h"
#include "OptionsDialog.h"	// Added by ClassView
#include "Timer_input.h"
#include "TimerOutput.h"
#include "UART.h"
#include "XTabCtrl.h"
#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
/////////////////////////////////////////////////////////////////////////////
// CGPIOInitializationGUIDlg dialog
class CGPIOInitializationGUIDlg : public CDialog
{
// Construction
public:
	void CreateHeaderFile();
	void CreateMainFile();
	void CreateGpioFile();
	void CreateTimerFile();
	void CreateUARTFile();
	void FormatCode(CString *);
	CString constring,CCode,CCodeSet;
	int i;
	int userchoice;
	CGPIOInitializationGUIDlg(CWnd* pParent = NULL);	// standard constructor
	ofstream outfile;
	CFont boldfont;								
// Dialog Data
	//{{AFX_DATA(CGPIOInitializationGUIDlg)
	enum { IDD = IDD_GPIOINITIALIZATIONGUI_DIALOG };
	CStatic	m_pc0;
	CStatic	m_pb1;
	CStatic	m_pb0;
	CStatic	m_pa7;
	CStatic	m_pa6;
	CStatic	m_pa5;
	CStatic	m_pa4;
	CStatic	m_pa3;
	CStatic	m_pa2;
	CStatic	m_pa1;
	CStatic	m_pa0;
	CStatic	m_label;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CGPIOInitializationGUIDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	virtual void CalcWindowRect(LPRECT lpClientRect, UINT nAdjustType = adjustBorder);
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	//{{AFX_MSG(CGPIOInitializationGUIDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnButton8();
	afx_msg void OnButton9();
	afx_msg void OnButton10();
	afx_msg void OnButton11();
	afx_msg void OnButton12();
	afx_msg void OnButton13();
	afx_msg void OnButton1();
	afx_msg void OnButton2();
	afx_msg void OnButton22();
	afx_msg void OnButtonGcode();
	afx_msg void OnButton19();
	afx_msg void OnButton18();
	afx_msg void OnButton20();
	afx_msg void OnReset();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
private:
    GPIOoptions PortA_gpio_opt[8];
	GPIOoptions PortB_gpio_opt[2];
	GPIOoptions PortC_gpio_opt[1];
	OptionsDialog PortA_opt[8];
	OptionsDialog PortB_opt[2];
	OptionsDialog PortC_opt[1];	
	Timer_input T0IN,T1IN;
	TimerOutput T0OUT;
	UART UART_opt;
};


//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_GPIOINITIALIZATIONGUIDLG_H__A5480EB8_9030_415B_ACFB_28EF44AD0614__INCLUDED_)
