// IRQ0.cpp : implementation file
//

#include "stdafx.h"
#include "GPIO Initialization GUI.h"
#include "IRQ0.h"
#include"XTabCtrl.h"
#include"registers.h"
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// IRQ0 dialog


IRQ0::IRQ0(CWnd* pParent /*=NULL*/)
	: CDialog(IRQ0::IDD, pParent)
{
	//{{AFX_DATA_INIT(IRQ0)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void IRQ0::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(IRQ0)
	DDX_Control(pDX, IDC_BIT1, m_BIT1);
	DDX_Control(pDX, IDC_BIT0, m_BIT0);
	DDX_Control(pDX, IDC_IRQ0ENL7, m_irq0enl7);
	DDX_Control(pDX, IDC_IRQ0ENL6, m_irq0enl6);
	DDX_Control(pDX, IDC_IRQ0ENL5, m_irq0enl5);
	DDX_Control(pDX, IDC_IRQ0ENL4, m_irq0enl4);
	DDX_Control(pDX, IDC_IRQ0ENL3, m_irq0enl3);
	DDX_Control(pDX, IDC_IRQ0ENL2, m_irq0enl2);
	DDX_Control(pDX, IDC_IRQ0ENL1, m_irq0enl1);
	DDX_Control(pDX, IDC_IRQ0ENL0, m_irq0enl0);
	DDX_Control(pDX, IDC_IRQ0ENH7, m_irq0enh7);
	DDX_Control(pDX, IDC_IRQ0ENH6, m_irq0enh6);
	DDX_Control(pDX, IDC_IRQ0ENH5, m_irq0enh5);
	DDX_Control(pDX, IDC_IRQ0ENH4, m_irq0enh4);
	DDX_Control(pDX, IDC_IRQ0ENH3, m_irq0enh3);
	DDX_Control(pDX, IDC_IRQ0ENH2, m_irq0enh2);
	DDX_Control(pDX, IDC_IRQ0ENH1, m_irq0enh1);
	DDX_Control(pDX, IDC_IRQ0ENH0, m_irq0enh0);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(IRQ0, CDialog)
	//{{AFX_MSG_MAP(IRQ0)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// IRQ0 message handlers

void IRQ0::RefreshIRQ0ENH()
{
		registers::IRQ0ENH&1? m_irq0enh0.SetBitmap(bit1):m_irq0enh0.SetBitmap(bit0);	
		registers::IRQ0ENH&2? m_irq0enh1.SetBitmap(bit1):m_irq0enh1.SetBitmap(bit0);	
		registers::IRQ0ENH&4? m_irq0enh2.SetBitmap(bit1):m_irq0enh2.SetBitmap(bit0);	
		registers::IRQ0ENH&8? m_irq0enh3.SetBitmap(bit1):m_irq0enh3.SetBitmap(bit0);	
		registers::IRQ0ENH&16? m_irq0enh4.SetBitmap(bit1):m_irq0enh4.SetBitmap(bit0);	
		registers::IRQ0ENH&32? m_irq0enh5.SetBitmap(bit1):m_irq0enh5.SetBitmap(bit0);	
		registers::IRQ0ENH&64? m_irq0enh6.SetBitmap(bit1):m_irq0enh6.SetBitmap(bit0);	
		registers::IRQ0ENH&128? m_irq0enh7.SetBitmap(bit1):m_irq0enh7.SetBitmap(bit0);	
}

void IRQ0::RefreshIRQ0ENL()
{
		registers::IRQ0ENL&1? m_irq0enl0.SetBitmap(bit1):m_irq0enl0.SetBitmap(bit0);	
		registers::IRQ0ENL&2? m_irq0enl1.SetBitmap(bit1):m_irq0enl1.SetBitmap(bit0);	
		registers::IRQ0ENL&4? m_irq0enl2.SetBitmap(bit1):m_irq0enl2.SetBitmap(bit0);	
		registers::IRQ0ENL&8? m_irq0enl3.SetBitmap(bit1):m_irq0enl3.SetBitmap(bit0);	
		registers::IRQ0ENL&16? m_irq0enl4.SetBitmap(bit1):m_irq0enl4.SetBitmap(bit0);	
		registers::IRQ0ENL&32? m_irq0enl5.SetBitmap(bit1):m_irq0enl5.SetBitmap(bit0);	
		registers::IRQ0ENL&64? m_irq0enl6.SetBitmap(bit1):m_irq0enl6.SetBitmap(bit0);	
		registers::IRQ0ENL&128? m_irq0enl7.SetBitmap(bit1):m_irq0enl7.SetBitmap(bit0);	
}



BOOL IRQ0::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
	bit0=m_BIT0.GetBitmap();
	bit1=m_BIT1.GetBitmap();
	RefreshIRQ0ENH();
	RefreshIRQ0ENL();
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}
