// OptionsDialog.cpp : implementation file
//

#include "stdafx.h"
#include "GPIO Initialization GUI.h"
#include "GPIOoptions.h"
#include "OptionsDialog.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// OptionsDialog dialog


OptionsDialog::OptionsDialog(CWnd* pParent /*=NULL*/)
	: CDialog(OptionsDialog::IDD, pParent)
{
	//{{AFX_DATA_INIT(OptionsDialog)
	m_iPinOption = 0;
	configured=FALSE;
	//}}AFX_DATA_INIT
}


void OptionsDialog::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(OptionsDialog)
	DDX_Radio(pDX, IDC_GPIO_RADIO, m_iPinOption);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(OptionsDialog, CDialog)
	//{{AFX_MSG_MAP(OptionsDialog)
	ON_BN_CLICKED(IDC_BUTTON_CANCEL, OnButtonCancel)
	ON_WM_CANCELMODE()
	ON_WM_CAPTURECHANGED()
	ON_BN_CLICKED(IDC_BUTTON_NEXT, OnButtonNext)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// OptionsDialog message handlers

BOOL OptionsDialog::OnInitDialog() 
{
	CDialog::OnInitDialog();
	UpdateData(FALSE);
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}



void OptionsDialog::OnButtonCancel() 
{
	// TODO: Add your control notification handler code here
	OnCancel();
	
}

void OptionsDialog::OnButtonNext() 
{
	UpdateData(TRUE);//retrive data from the form
	
	OnOK();
		
	// TODO: Add your control notification handler code here
	
}
