#if !defined(AFX_TIMER_INPUT_H__290BB1D5_DD38_4E81_B131_4EF6BFE16A03__INCLUDED_)
#define AFX_TIMER_INPUT_H__290BB1D5_DD38_4E81_B131_4EF6BFE16A03__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// Timer_input.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// Timer_input dialog

class Timer_input : public CDialog
{
	CFont boldfont;
	void RefreshT0CTL();
	void RefreshT1CTL();
	void RefreshIRQ0ENL();
	void RefreshIRQ0ENH();

public:
	HBITMAP bit0,bit1;
	int tnum;//timer number.
// Construction
	Timer_input(CWnd* pParent = NULL);   // standard constructor

// Dialog Data
	//{{AFX_DATA(Timer_input)
	enum { IDD = IDD_TIMER_IN };
	CStatic	m_BIT1;
	CStatic	m_BIT0;
	CStatic	m_irq0enl7;
	CStatic	m_irq0enl6;
	CStatic	m_irq0enl5;
	CStatic	m_irq0enl4;
	CStatic	m_irq0enl3;
	CStatic	m_irq0enl2;
	CStatic	m_irq0enl1;
	CStatic	m_irq0enl0;
	CStatic	m_irq0enh7;
	CStatic	m_irq0enh6;
	CStatic	m_irq0enh5;
	CStatic	m_irq0enh4;
	CStatic	m_irq0enh3;
	CStatic	m_irq0enh2;
	CStatic	m_irq0enh1;
	CStatic	m_irq0enh0;
	CStatic	m_tctl_label;
	CStatic	m_tlabel;
	CStatic	m_tctl7;
	CStatic	m_tctl6;
	CStatic	m_tctl5;
	CStatic	m_tctl4;
	CStatic	m_tctl3;
	CStatic	m_tctl2;
	CStatic	m_tctl1;
	CStatic	m_tctl0;
	int		m_tmode;
	int		m_prescale;
	int		m_interrupt_opt;
	int		m_tpol;
	int		PWMH;
	int		PWML;
	int		RH;
	int		RL;
	int		TL;
	int		TH;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(Timer_input)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(Timer_input)
	virtual BOOL OnInitDialog();
	virtual void OnOK();
	afx_msg void OnSelchangeMode();
	afx_msg void OnSelchangePrescale();
	afx_msg void OnSelchangePolarity();
	afx_msg void OnSelchangeComboInterrupt();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_TIMER_INPUT_H__290BB1D5_DD38_4E81_B131_4EF6BFE16A03__INCLUDED_)
