#if !defined(AFX_UART_H__3C5BF01C_23E7_46DB_937E_1D85E60CB146__INCLUDED_)
#define AFX_UART_H__3C5BF01C_23E7_46DB_937E_1D85E60CB146__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// UART.h : header file
//
#include "U0CTL.h"
#include "IRQ0.h"
/////////////////////////////////////////////////////////////////////////////
// UART dialog
#include"XTabCtrl.h"
class UART : public CDialog
{
// Construction
	HBITMAP bit0,bit1;
	void RefreshBRG();
	int baudrate;
	unsigned int brg;
public:
	void OnDestroy();
	UART(CWnd* pParent = NULL);   // standard constructor
	U0CTL *u0ctl;
	IRQ0 *irq0;

// Dialog Data
	//{{AFX_DATA(UART)
	enum { IDD = IDD_UART };
	CStatic	m_BIT1;
	CStatic	m_BIT0;
	CStatic	m_ubrh0;
	CXTabCtrl	m_tab;
	CStatic	m_ubrl7;
	CStatic	m_ubrl6;
	CStatic	m_ubrl5;
	CStatic	m_ubrl4;
	CStatic	m_ubrl3;
	CStatic	m_ubrl2;
	CStatic	m_ubrl1;
	CStatic	m_ubrl0;
	CStatic	m_ubrh7;
	CStatic	m_ubrh6;
	CStatic	m_ubrh5;
	CStatic	m_ubrh4;
	CStatic	m_ubrh3;
	CStatic	m_ubrh2;
	CStatic	m_ubrh1;
	int		m_baud_rate;
	int		m_ctse;
	int		m_mpbt;
	int		m_mpen;
	int		m_parity;
	int		m_reciever;
	int		m_reciever_interrupt;
	int		m_transmit;
	int		m_transmitter_interrupt;
	int		m_mpmd;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(UART)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(UART)
	afx_msg void OnSelchangeBaudRate();
	afx_msg void OnSelchangeParity();
	afx_msg void OnSelchangeMpen();
	afx_msg void OnSelchangeMpmd();
	afx_msg void OnSelchangeTransmit();
	afx_msg void OnSelchangeTransmitterInterrupt();
	afx_msg void OnSelchangeCtse();
	afx_msg void OnSelchangeReciever();
	afx_msg void OnSelchangeRecieverInterrupt();
	afx_msg void OnSelchangeMpbt();
	afx_msg void OnSetfocusParity();
	afx_msg void OnSetfocusMpen();
	virtual BOOL OnInitDialog();
	afx_msg void OnSetfocusMpmd();
	afx_msg void OnSetfocusMpbt();
	afx_msg void OnSetfocusTransmit();
	afx_msg void OnSetfocusTransmitterInterrupt();
	afx_msg void OnSetfocusCtse();
	afx_msg void OnSetfocusReciever();
	afx_msg void OnSetfocusRecieverInterrupt();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_UART_H__3C5BF01C_23E7_46DB_937E_1D85E60CB146__INCLUDED_)
